version: '3.7'

services:
  prometheus:
    image: prom/prometheus:v2.1.0
    volumes:
      - ./prometheus/:/etc/prometheus/
      - prometheus_data:/prometheus
    command:
      - '--config.file=/etc/prometheus/prometheus.yml'
      - '--storage.tsdb.path=/prometheus'
      - '--web.console.libraries=/usr/share/prometheus/console_libraries'
      - '--web.console.templates=/usr/share/prometheus/consoles'
    networks:
      - back-tier
      - ingress
    restart: always

  node-exporter:
    image: prom/node-exporter
    volumes:
      - /proc:/host/proc:ro
      - /sys:/host/sys:ro
      - /:/rootfs:ro
    command: 
      - '--path.procfs=/host/proc' 
      - '--path.sysfs=/host/sys'
      - --collector.filesystem.ignored-mount-points
      - "^/(sys|proc|dev|host|etc|rootfs/var/lib/docker/containers|rootfs/var/lib/docker/overlay2|rootfs/run/docker/netns|rootfs/var/lib/docker/aufs)($$|/)"
    networks:
      - back-tier
    restart: always
    deploy:
      mode: global

  alertmanager:
    image: prom/alertmanager
    volumes:
      - ./alertmanager/:/etc/alertmanager/
    networks:
      - back-tier
    restart: always
    command:
      - '--config.file=/etc/alertmanager/config.yml'
      - '--storage.path=/alertmanager'
  
  cadvisor:
    image: google/cadvisor
    volumes:
      - /:/rootfs:ro
      - /var/run:/var/run:rw
      - /sys:/sys:ro
      - /var/lib/docker/:/var/lib/docker:ro
    networks:
      - back-tier
    restart: always
    deploy:
      mode: global

  grafana:
    image: grafana/grafana
    user: "472"
    depends_on:
      - prometheus
    volumes:
      - grafana_data:/var/lib/grafana
      - ./grafana/provisioning/:/etc/grafana/provisioning/
    env_file:
      - ./grafana/config.monitoring
    networks:
      - back-tier
      - ingress
    restart: always
    labels:
      - "traefik.enable=true"
      - "traefik.docker.network=${INGRESS_NETWORK}"
      - "traefik.http.routers.monitor-r1-${UUID}-grafana.rule=Host(`monitor.$BASE_DOMAIN`)"
      - "traefik.http.routers.monitor-r1-${UUID}-grafana.entryPoints=http"
      - "traefik.http.services.monitor-r1-${UUID}-grafana.loadbalancer.server.port=3000"
      - "traefik.http.routers.monitor-r1-${UUID}-grafana-ssl.rule=Host(`monitor.$BASE_DOMAIN`)"
      - "traefik.http.routers.monitor-r1-${UUID}-grafana-ssl.entryPoints=https"
      - "traefik.http.routers.monitor-r1-${UUID}-grafana-ssl.tls=true"
      - "traefik.http.routers.monitor-r1-${UUID}-grafana-ssl.tls.certresolver=le"
      - "traefik.http.routers.monitor-r1-${UUID}-grafana-ssl.service=monitor-r1-${UUID}-grafana"
 

volumes:
    prometheus_data: {}
    grafana_data: {}

networks:
  back-tier:
  ingress:
    external:
      name: ${INGRESS_NETWORK}
